Instruction.push_back("ACI");
Instruction.push_back("ADC");
Instruction.push_back("ADD");
Instruction.push_back("ADI");
Instruction.push_back("ANA");

Parameters["ADI"] = 1;
Parameters["ANA"] = 1;
Parameters["ADC"] = 1;
Parameters["ACI"] = 1;
Parameters["ADD"] = 1;

/* In ACI ,the 8-bit data (operand) and the Carry flag are added to the
contents of the accumulator and the result is stored in the accumulator.
All flags are modified to reflect the result of the addition.*/
void ACI(int n)
{
    //n is decimal number
    Register[IndexOfRegister["A"]]+=n+Flag[IndexOfFlag["CY"]];
    Update();
}

/* IN ADC the contents of the operand (register or memory) and the Carry
flag are added to the contents of the accumulator and the result is stored
in the accumulator. If the operand is a memory location, its location is
specified by the contents of the HL registers. All flags are modified to
reflect the result of the addition.*/
void ADC(string a)
{
    Register[IndexOfRegister["A"]]+=Register[IndexOfRegister[a]]+Flag[IndexOfFlag["CY"]];
    Update();
}

/* In ADD the contents of the operand (register or memory) are added to the
contents of the accumulator and the result is stored in the accumulator. If
the operand is a memory location, its location is specified by the contents
of the HL registers. All flags are modified to reflect the result of the addition.*/
void ADC(string a)
{
    Register[IndexOfRegister["A"]]+=Register[IndexOfRegister[a]];
    Update();
}

/*In ADI the 8-bit data (operand) is added to the contents of the accumulator
and the result is stored in the accumulator. All flags are modified to reflect
the result of the addition.*/
void ADC(int n)
{
//n is decimal number
    Register[IndexOfRegister["A"]]+=n;
    Update();
}

/* In ANA the 8-bit data (operand) is added to the contents of the accumulator
and the result is stored in the accumulator. All flags are modified to reflect
the result of the addition.*/
void ANA(string a)
{
    Register[IndexOfRegister["A"]]=Register[IndexOfRegister["A"]]&Register[IndexOfRegister[a]];
    Update();
}
