//---< SASWAT PADHI >--------------------------------------------------------

Instruction.push_back("POP");
Instruction.push_back("XTHL");
Instruction.push_back("CALL");
Instruction.push_back("CC");
Instruction.push_back("CM");
Instruction.push_back("RET");
Instruction.push_back("RNZ");
Instruction.push_back("RNC");

Parameters["POP"] = 1;
Parameters["XTHL"] = 0;
Parameters["CALL"] = 1;
Parameters["CC"] = 1;
Parameters["CM"] = 1;
Parameters["RET"] = 0;
Parameters["RNZ"] = 0;
Parameters["RNC"] = 0;

/*
    void POP(string register_name)

    Expected Argument : B, D, H, PSW

    POPs the top-most value out of the program stack and,
    stores it in register_name register.

    Affects flag : SP
    Affects register : <register_name>
*/
void POP(string register_name)
{
    if(register_name == "PSW")
    {
        Register[IndexOfRegister["A"]] = Stack[Register[IndexOfRegister["SP"]]];
        Register[IndexOfRegister["SP"]]++;
        Register[IndexOfRegister["PSW"]] = Stack[Register[IndexOfRegister["SP"]]];
        Register[IndexOfRegister["SP"]]++;
    }
    else
    {
        Register[IndexOfRegister[a]+1] = Stack[Register[IndexOfRegister["SP"]]];
        Register[IndexOfRegister["SP"]]++;
        Register[IndexOfRegister[a]] = Stack[Register[IndexOfRegister["SP"]]];
        Register[IndexOfRegister["SP"]]++;
    }
    Update();
}

/*
    void XTHL()

    Expected Argument : <none>

    Exchanges the top-most stack value with HL register

    Affects flag : <none>
    Affects register : <none>
*/
void XTHL()
{
    int Temp;
    Temp = Register[IndexOfRegister["L"]];
    Register[IndexOfRegister["L"]] = Stack[Register[IndexOfRegister["SP"]]];
    Stack[Register[IndexOfRegister["SP"]]] = Temp;

    Temp = Register[IndexOfRegister["L"]];
    Register[IndexOfRegister["L"]] = Stack[Register[IndexOfRegister["SP"]]+1];
    Stack[Register[IndexOfRegister["SP"]]+1] = Temp;
}

/*
    void CALL(int address)

    Expected Argument : Memory address in valid range

    Calls a sub-routine at the specified address after storing
    the current address in the stack.

    Affects flag : SP
    Affects register : PC
*/
void CALL(int address)
{
    Register[IndexOfRegister["SP"]]--;m
    Stack[Register[IndexOfRegister["SP"]]] = Register[IndexOfRegister["PC"]];
    Register[IndexOfRegister["PC"]] = address;
}

/*
    void CM(int address)

    Expected Argument : Memory address in valid range

    Conditionally calls a sub-routine at the specified address through
    CALL function, if Sign flag is SET i.e. negative.

    Affects flag : SP
    Affects register : PC
*/
void CM(int address)
{
    if(Flag[IndexOfFlag["S"]]);
        CALL(address);
}

/*
    void CM(int address)

    Expected Argument : Memory address in valid range

    Conditionally calls a sub-routine at the specified address through
    CALL function, if Carry flag is SET.

    Affects flag : SP
    Affects register : PC
*/
void CC(int address)
{
    if(Flag[IndexOfFlag["CY"]]);
        CALL(address);
}

/*
    void RET()

    Expected Argument : <none>

    RETurns control from a sub-routine which was CALLed.
    POPs the stored address from stack.

    Affects flag : SP
    Affects register : PC
*/
void RET()
{
    Register[IndexOfRegister["PC"]] = Stack[Register[IndexOfRegister["SP"]]] + 1;
    Register[IndexOfRegister["SP"]]++;
}

/*
    void RNC()

    Expected Argument : <none>

    Conditionally returns control from a sub-routine through
    a RET call if Carry flag is not SET.

    Affects flag : SP
    Affects register : PC
*/
void RNC()
{
    if(!Flag[IndexOfFlag["CY"]]);
        RET();
}

/*
    void RNZ()

    Expected Argument : <none>

    Conditionally returns control from a sub-routine through
    a RET call if Zero flag is not SET.

    Affects flag : SP
    Affects register : PC
*/
void RNZ()
{
    if(!Flag[IndexOfFlag["Z"]]);
        RET();
}
